"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _rest = require("@octokit/rest");

var _chalk = _interopRequireDefault(require("chalk"));

var _commander = _interopRequireDefault(require("commander"));

var LinkHeader = _interopRequireWildcard(require("http-link-header"));

var mime = _interopRequireWildcard(require("mime-types"));

var _minimatch = _interopRequireDefault(require("minimatch"));

var _urlParse = _interopRequireDefault(require("url-parse"));

var _ora = _interopRequireDefault(require("ora"));

var _package = _interopRequireDefault(require("../package.json"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

_commander["default"].version(_package["default"].version).usage('<command> [<args>]').option('--baseurl <baseurl>', 'API endpoint', 'https://api.github.com').option('--token <token>', 'OAuth2 token', null).option('--owner <owner>', 'The repository owner.', '').option('--repo <repo>', 'The repository name.', '').option('--tag <tag>', 'The name of the tag.').option('--commitish <value>', 'Specifies the commitish value for tag. Unused if the tag already exists.').option('--release-id <id>', 'The release id.').option('--release-name <name>', 'The name of the release.', '').option('--body <body>', 'Text describing the contents of the tag.').option('--draft [value]', '`true` makes the release a draft, and `false` publishes the release.', function (val) {
  if (String(val).toLowerCase() === 'false') {
    return false;
  }

  return true;
}).option('--prerelease [value]', '`true` to identify the release as a prerelease, `false` to identify the release as a full release.', function (val) {
  if (String(val).toLowerCase() === 'false') {
    return false;
  }

  return true;
});

_commander["default"].parse(process.argv);

var _program$args = (0, _toArray2["default"])(_commander["default"].args),
    command = _program$args[0],
    args = _program$args.slice(1);

var token = _commander["default"].token || process.env.GITHUB_TOKEN;
var octokit = new _rest.Octokit({
  auth: token || null,
  baseUrl: _commander["default"].baseurl
});

var getNextPage = function getNextPage(response) {
  if (!response.headers || !response.headers.link) {
    return false;
  }

  var link = LinkHeader.parse(response.headers.link).rel('next');

  if (!link || !link[0]) {
    return false;
  }

  var url = (0, _urlParse["default"])(link[0].uri, null, true);

  if (!url.query) {
    return false;
  }

  var nextPage = parseInt(url.query.page);
  return nextPage;
};

var getReleaseByTag = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref) {
    var owner, repo, tag, res, release, page, _res, releases, _iterator, _step, _release;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            owner = _ref.owner, repo = _ref.repo, tag = _ref.tag;
            _context.prev = 1;
            _context.next = 4;
            return octokit.repos.getReleaseByTag({
              owner: owner,
              repo: repo,
              tag: tag
            });

          case 4:
            res = _context.sent;
            release = res.data;
            return _context.abrupt("return", release);

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](1);

          case 11:
            _context.prev = 11;
            page = 1;

          case 13:
            _context.next = 15;
            return octokit.repos.listReleases({
              owner: owner,
              repo: repo,
              page: page
            });

          case 15:
            _res = _context.sent;
            releases = _res.data;
            _iterator = _createForOfIteratorHelper(releases);
            _context.prev = 18;

            _iterator.s();

          case 20:
            if ((_step = _iterator.n()).done) {
              _context.next = 26;
              break;
            }

            _release = _step.value;

            if (!(_release.tag_name === tag)) {
              _context.next = 24;
              break;
            }

            return _context.abrupt("return", _release);

          case 24:
            _context.next = 20;
            break;

          case 26:
            _context.next = 31;
            break;

          case 28:
            _context.prev = 28;
            _context.t1 = _context["catch"](18);

            _iterator.e(_context.t1);

          case 31:
            _context.prev = 31;

            _iterator.f();

            return _context.finish(31);

          case 34:
            page = getNextPage(_res);

          case 35:
            if (page) {
              _context.next = 13;
              break;
            }

          case 36:
            _context.next = 40;
            break;

          case 38:
            _context.prev = 38;
            _context.t2 = _context["catch"](11);

          case 40:
            console.log('No release found.');
            return _context.abrupt("return", null);

          case 42:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[1, 9], [11, 38], [18, 28, 31, 34]]);
  }));

  return function getReleaseByTag(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var parseBody = function parseBody(str) {
  try {
    return JSON.parse(str);
  } catch (err) {
    return str;
  }
};

var fn = {
  'upload': function () {
    var _upload = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var owner, repo, tag, commitish, releaseId, releaseName, body, draft, prerelease, files, release, res, _res2, _res3, i, file;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              owner = _commander["default"].owner, repo = _commander["default"].repo, tag = _commander["default"].tag, commitish = _commander["default"].commitish, releaseId = _commander["default"].releaseId, releaseName = _commander["default"].releaseName, body = _commander["default"].body, draft = _commander["default"].draft, prerelease = _commander["default"].prerelease;
              files = args;
              _context2.prev = 2;

              if (!tag) {
                _context2.next = 10;
                break;
              }

              console.log("> getReleaseByTag: owner=".concat(owner, ", repo=").concat(repo, ", tag=").concat(tag));
              _context2.next = 7;
              return getReleaseByTag({
                owner: owner,
                repo: repo,
                tag: tag
              });

            case 7:
              release = _context2.sent;
              _context2.next = 16;
              break;

            case 10:
              if (!releaseId) {
                _context2.next = 16;
                break;
              }

              console.log("> getRelease: owner=".concat(owner, ", repo=").concat(repo, ", release_id=").concat(releaseId));
              _context2.next = 14;
              return octokit.repos.getRelease({
                owner: owner,
                repo: repo,
                release_id: releaseId
              });

            case 14:
              res = _context2.sent;
              release = res.data;

            case 16:
              _context2.next = 20;
              break;

            case 18:
              _context2.prev = 18;
              _context2.t0 = _context2["catch"](2);

            case 20:
              _context2.prev = 20;

              if (release) {
                _context2.next = 29;
                break;
              }

              console.log("> createRelease: tag_name=".concat(tag, ", target_commitish=").concat(commitish || '', ", name=").concat(releaseName || tag, ", draft=").concat(!!draft, ", prerelease=").concat(!!prerelease));
              _context2.next = 25;
              return octokit.repos.createRelease({
                owner: owner,
                repo: repo,
                tag_name: tag,
                target_commitish: commitish,
                name: releaseName || tag,
                body: parseBody(body) || '',
                draft: !!draft,
                prerelease: !!prerelease
              });

            case 25:
              _res2 = _context2.sent;
              release = _res2.data;
              _context2.next = 34;
              break;

            case 29:
              console.log("> updateRelease: release_id=".concat(release.id, ", tag_name=").concat(tag, ", name=").concat(releaseName || tag));
              _context2.next = 32;
              return octokit.repos.updateRelease({
                owner: owner,
                repo: repo,
                release_id: release.id,
                tag_name: tag,
                name: releaseName || tag,
                body: body === undefined ? release.body || '' : parseBody(body) || '',
                draft: draft === undefined ? !!release.draft : false,
                prerelease: prerelease === undefined ? !!release.prerelease : false
              });

            case 32:
              _res3 = _context2.sent;
              release = _res3.data;

            case 34:
              if (!(files.length > 0)) {
                _context2.next = 45;
                break;
              }

              console.log("> uploadReleaseAsset: assets_url=".concat(release.assets_url));
              i = 0;

            case 37:
              if (!(i < files.length)) {
                _context2.next = 45;
                break;
              }

              file = files[i];
              console.log("  #".concat(i + 1, ": name=\"").concat(_path["default"].basename(file), "\" filePath=\"").concat(file, "\""));
              _context2.next = 42;
              return octokit.repos.uploadReleaseAsset({
                url: release.upload_url,
                data: _fs["default"].createReadStream(file),
                headers: {
                  'Content-Type': mime.lookup(file) || 'application/octet-stream',
                  'Content-Length': _fs["default"].statSync(file).size
                },
                name: _path["default"].basename(file)
              });

            case 42:
              ++i;
              _context2.next = 37;
              break;

            case 45:
              _context2.next = 50;
              break;

            case 47:
              _context2.prev = 47;
              _context2.t1 = _context2["catch"](20);
              console.error(_context2.t1);

            case 50:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[2, 18], [20, 47]]);
    }));

    function upload() {
      return _upload.apply(this, arguments);
    }

    return upload;
  }(),
  'delete': function () {
    var _delete2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var owner, repo, tag, releaseId, patterns, release, res, release_id, _release_id, assets, page, _res4, deleteAssets, i, asset;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              owner = _commander["default"].owner, repo = _commander["default"].repo, tag = _commander["default"].tag, releaseId = _commander["default"].releaseId;
              patterns = args;
              _context3.prev = 2;

              if (!tag) {
                _context3.next = 10;
                break;
              }

              console.log("> getReleaseByTag: owner=".concat(owner, ", repo=").concat(repo, ", tag=").concat(tag));
              _context3.next = 7;
              return getReleaseByTag({
                owner: owner,
                repo: repo,
                tag: tag
              });

            case 7:
              release = _context3.sent;
              _context3.next = 16;
              break;

            case 10:
              if (!releaseId) {
                _context3.next = 16;
                break;
              }

              console.log("> getRelease: owner=".concat(owner, ", repo=").concat(repo, ", release_id=").concat(releaseId));
              _context3.next = 14;
              return octokit.repos.getRelease({
                owner: owner,
                repo: repo,
                release_id: releaseId
              });

            case 14:
              res = _context3.sent;
              release = res.data;

            case 16:
              if (release) {
                _context3.next = 18;
                break;
              }

              return _context3.abrupt("return");

            case 18:
              if (!(patterns.length === 0)) {
                _context3.next = 24;
                break;
              }

              release_id = release.id;
              console.log("> deleteRelease: release_id=".concat(release_id));
              _context3.next = 23;
              return octokit.repos.deleteRelease({
                owner: owner,
                repo: repo,
                release_id: release.id
              });

            case 23:
              return _context3.abrupt("return");

            case 24:
              _context3.next = 30;
              break;

            case 26:
              _context3.prev = 26;
              _context3.t0 = _context3["catch"](2);
              console.error(_context3.t0);
              return _context3.abrupt("return");

            case 30:
              _context3.prev = 30;
              _release_id = release.id;
              console.log("> listReleaseAssets: release_id=".concat(_release_id));
              assets = [];
              page = 1;

            case 35:
              _context3.next = 37;
              return octokit.repos.listReleaseAssets({
                owner: owner,
                repo: repo,
                release_id: _release_id,
                page: page
              });

            case 37:
              _res4 = _context3.sent;
              assets = assets.concat(_res4.data);
              page = getNextPage(_res4);

            case 40:
              if (page) {
                _context3.next = 35;
                break;
              }

            case 41:
              deleteAssets = assets.filter(function (asset) {
                return patterns.some(function (pattern) {
                  return (0, _minimatch["default"])(asset.name, pattern);
                });
              });
              console.log("  assets=".concat(assets.length, ", deleteAssets=").concat(deleteAssets.length));

              if (!(deleteAssets.length > 0)) {
                _context3.next = 54;
                break;
              }

              console.log('> deleteReleaseAsset:');
              i = 0;

            case 46:
              if (!(i < deleteAssets.length)) {
                _context3.next = 54;
                break;
              }

              asset = deleteAssets[i];
              console.log("  #".concat(i + 1, ":"), {
                id: asset.id,
                name: asset.name,
                label: asset.label,
                state: asset.state,
                size: asset.size,
                download_count: asset.download_count,
                created_at: asset.created_at,
                updated_at: asset.updated_at
              });
              _context3.next = 51;
              return octokit.repos.deleteReleaseAsset({
                owner: owner,
                repo: repo,
                asset_id: asset.id
              });

            case 51:
              ++i;
              _context3.next = 46;
              break;

            case 54:
              _context3.next = 59;
              break;

            case 56:
              _context3.prev = 56;
              _context3.t1 = _context3["catch"](30);
              console.error(_context3.t1);

            case 59:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[2, 26], [30, 56]]);
    }));

    function _delete() {
      return _delete2.apply(this, arguments);
    }

    return _delete;
  }(),
  'list': function () {
    var _list = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      var owner, repo, releases, spinner, page, res, _iterator2, _step2, release, prefix;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              owner = _commander["default"].owner, repo = _commander["default"].repo;
              releases = [];
              spinner = (0, _ora["default"])({
                spinner: 'point',
                text: 'Fetching...'
              }).start();
              _context4.prev = 3;
              page = 1;

            case 5:
              _context4.next = 7;
              return octokit.repos.listReleases({
                owner: owner,
                repo: repo,
                page: page
              });

            case 7:
              res = _context4.sent;
              releases = releases.concat(res.data);
              page = getNextPage(res);

            case 10:
              if (page) {
                _context4.next = 5;
                break;
              }

            case 11:
              _context4.next = 16;
              break;

            case 13:
              _context4.prev = 13;
              _context4.t0 = _context4["catch"](3);
              console.error(_context4.t0);

            case 16:
              spinner.stop();
              _iterator2 = _createForOfIteratorHelper(releases);

              try {
                for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                  release = _step2.value;
                  prefix = 'RELEASE';

                  if (release.draft) {
                    prefix = 'DRAFT';
                  }

                  if (release.prerelease) {
                    prefix = 'PRERELEASE';
                  }

                  console.log("".concat(_chalk["default"].blue('●'), " [").concat(prefix, "] id=").concat(_chalk["default"].cyan(release.id), ", tag_name=").concat(_chalk["default"].yellow(JSON.stringify(release.tag_name)), ", name=").concat(_chalk["default"].yellow(JSON.stringify(release.name)), ", created_at=").concat(_chalk["default"].yellow(release.created_at), ", published_at=").concat(_chalk["default"].yellow(release.published_at)));
                }
              } catch (err) {
                _iterator2.e(err);
              } finally {
                _iterator2.f();
              }

            case 19:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, null, [[3, 13]]);
    }));

    function list() {
      return _list.apply(this, arguments);
    }

    return list;
  }()
}[command];

function main() {
  return _main.apply(this, arguments);
}

function _main() {
  _main = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
    var message;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.prev = 0;
            _context5.t0 = typeof fn === 'function';

            if (!_context5.t0) {
              _context5.next = 5;
              break;
            }

            _context5.next = 5;
            return fn();

          case 5:
            _context5.next = 12;
            break;

          case 7:
            _context5.prev = 7;
            _context5.t1 = _context5["catch"](0);
            // message has token in the response
            message = _context5.t1.message.replace(/https?:[^\s]*/g, function (match) {
              return match.replace(/\?.*/, '');
            });
            console.log(message);
            process.exit(1);

          case 12:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[0, 7]]);
  }));
  return _main.apply(this, arguments);
}

main();